
local map = require('gloves.map')
local component = require('gloves.component')


local topdown = component:new()

topdown.speed_walk = 0.9
topdown.speed_run = 1.4

topdown.friction_walk = 0.7

topdown.input_angle = 0
topdown.input_walk = false
topdown.input_run = false

topdown.input_up = false
topdown.input_down = false
topdown.input_left = false
topdown.input_right = false


function topdown:update()

  if self.input_walk then
    if self.input_run then
      self.e.xa = self.e.xa + self.speed_run * math.sin(self.input_angle)
      self.e.ya = self.e.ya + self.speed_run * math.cos(self.input_angle)
    else
      self.e.xa = self.e.xa + self.speed_walk * math.sin(self.input_angle)
      self.e.ya = self.e.ya + self.speed_walk * math.cos(self.input_angle)
    end
  end

  --[[
  -- up and down
  if self.input_up then
    if self.input_run then
      self.e.ya = self.e.ya - self.speed_run
    else
      self.e.ya = self.e.ya - self.speed_walk
    end

    self.e.d = map.direction.U
  elseif self.input_down then
    if self.input_run then
      self.e.ya = self.e.ya + self.speed_run
    else
      self.e.ya = self.e.ya + self.speed_walk
    end

    self.e.d = map.direction.D
  end

  -- left and right
  if self.input_left then
    if self.input_run then
      self.e.xa = self.e.xa - self.speed_run
    else
      self.e.xa = self.e.xa - self.speed_walk
    end

    self.e.d = map.direction.L
  elseif self.input_right then
    if self.input_run then
      self.e.xa = self.e.xa + self.speed_run
    else
      self.e.xa = self.e.xa + self.speed_walk
    end

    self.e.d = map.direction.R
  end
  ]]

  -- actual change
  self.e.dx = self.e.xa
  self.e.dy = self.e.ya

  -- actual move
  self.e.map:move_entity(self.e, self.e.x + self.e.xa, self.e.y + self.e.ya)


  -- dampen

  -- walk friction
  -- gives a smooth accelerate and decelerate
  self.e.xa = self.e.xa * self.friction_walk
  self.e.ya = self.e.ya * self.friction_walk

  -- zero small acceleration
  -- so entity does not appear to hop after a few seconds standing still
  if self.e.ya > -0.1 and self.e.ya < 0.1 then
    self.e.ya = 0
  end

  if self.e.xa > -0.1 and self.e.xa < 0.1 then
    self.e.xa = 0
  end

end


return topdown
