
local vector = require('vector')
local Entity = require('entity')
local Sprite = require('sprite')

local Armor = Entity:new()


function Armor:init()
  -- super
  Entity.init(self)

  self.types.pickup = true
  self.types.armor = true

  self.w = 8
  self.h = 8

  self.sprite = Sprite:newSprite('armor', self)
end


function Armor:entityCollision(e2, nx, ny, dir)
  if e2.types.player then
    self.remove = true
  end
end


function Armor:update(dt)
  self.world:moveEntity(self, self.x, self.y)
  self.sprite:update(dt)
end


function Armor:draw()
  self.sprite.sheet.sb:add(self.sprite:getFrame(), self.x - 4, self.y - 4)
end


return Armor
