
local vector = require('vector')
local Entity = require('entity')
local Sprite = require('sprite')

local Ice = Entity:new()


function Ice:init()
  -- super
  Entity.init(self)

  self.types.creep = true
  self.types.ice = true

  self.w = 16
  self.h = 16
  self.d = 1
  self.speed = 0.9

  self.time = 0
  self.thinkTime = 2
  self.direction = { x = math.random(), y = math.random() }
  if math.random() < 0.5 then self.direction.x = -self.direction.x end
  if math.random() < 0.5 then self.direction.y = -self.direction.y end

  self.sprite = Sprite:newSprite('ice', self)
  self.state = 'birth'
  self.sprite:setState('birth')

  local sprite = self.sprite
  sprite.entity = self

  function sprite:endAnimation()
    if self.state == 'birth' then
      self.entity.state = 'stand'
    end

    if self.state == 'death' then
      self.entity.remove = true
    end
  end
end


function Ice:entityCollision(e2, nx, ny, dir)
  -- if e2.types.player then
  --   self.remove = true
  -- end
end


function Ice:entityCollision(e2, nx, ny, dir)
  if e2.types.pull then

  end

  self.x = nx
  self.y = ny
end


function Ice:update(dt)
  self.time = self.time + dt

  -- think
  if self.time > self.thinkTime then
    self.direction.x = math.random()
    self.direction.y = math.random()
    if math.random() < 0.5 then self.direction.x = -self.direction.x end
    if math.random() < 0.5 then self.direction.y = -self.direction.y end

    self.time = self.thinkTime - self.time
  end

  if self.state == 'stand' then
    self.state = 'walk'
  end

  if self.state == 'walk' then
    self.dx = self.direction.x * self.speed
    self.dy = self.direction.y * self.speed
  end

  if self.direction.x < 0 then
    self.d = -1
  else
    self.d = 1
  end

  if self.state ~= 'death' then
    self.world:moveEntity(self, self.x + self.dx, self.y + self.dy)
  end

  self.sprite:update(dt)

  if self.sprite.state ~= self.state then
    self.sprite:setState(self.state)
  end
end


function Ice:draw()
  local ox = 0
  if self.d == -1 then ox = self.w end

  self.sprite.sheet.sb:add(self.sprite:getFrame(), self.x, self.y, 0, self.d, 1, ox, 0)
end


return Ice
