
local vector = require('vector')
local Entity = require('entity')
local Sprite = require('sprite')

local Sword = Entity:new()


function Sword:init()
  -- super
  Entity.init(self)

  self.types.pickup = true
  self.types.sword = true

  self.w = 8
  self.h = 8

  self.sprite = Sprite:newSprite('sword', self)
end


function Sword:entityCollision(e2, nx, ny, dir)
  if e2.types.player then
    self.remove = true
  end
end


function Sword:update(dt)
  self.world:moveEntity(self, self.x, self.y)
  self.sprite:update(dt)
end


function Sword:draw()
  self.sprite.sheet.sb:add(self.sprite:getFrame(), self.x - 4, self.y - 4)
end


return Sword
