
--- The love2D entry point.

inspect = require('lib.inspect')
local Game = require('game')
local Play = require('screen.play')
local Spriter = require('screen.spriter')


local game = Game:new()

screen = {}
play = {}
intro = {}
credits = {}

--- The function Love2D will call to draw your game.
-- @tparam table arg command line arguments
function love.load(arg)
  love.graphics.setDefaultFilter('linear', 'nearest', 1)

  intro = require('screen.intro'):new()
  credits = require('screen.credits'):new()
  play = Play:new()

  screen = intro
  intro.music:play()
end


--- The function Love2D will call to update your game.
-- The dt is multiplied by 100 to allow the game to use smaller update numbers.
-- Will update the current screen.
-- @tparam number dt the delta time
function love.update(dt)
  screen:update(dt)
end


--- The function Love2D will call to draw your game.
-- Will draw the current screen.
function love.draw()
  screen:draw()
end
