
local Keyboard = require('keyboard')
local Camera = require('camera')


local Credits = {}


--- New menu screen.
function Credits:new(o)
  o = o or {}
  setmetatable(o, self)
  self.__index = self
  o:init()
  return o
end


function Credits:init()
  self.music = love.audio.newSource('music/intro.mp3')
  self.music:setVolume(4)

  self.keyboard = Keyboard:new()
  self.keyboard:action('escape', 'escape')

  self.creditsImage = game:image('image/credits.png')

  self.camera = Camera:new({
    x = 0,
    y = 0,
    w = love.graphics.getWidth(),
    h = love.graphics.getHeight()})
  self.camera.zoom = 4

  self.camera.x = -(love.graphics.getWidth() / self.camera.zoom - 128)
  self.camera.y = -(love.graphics.getHeight() / self.camera.zoom - 128) / 2

end


function Credits:update(dt)


  self.keyboard:update()
  -- if self.keyboard.now.escape then love.event.quit() end

end


function Credits:draw()
  self.camera:push()
  love.graphics.draw(self.creditsImage, 0, 0)
  self.camera:pop()
end


return Credits
