
local vector = require('vector')
local Camera = require('camera')
local Entity = require('entity')
local Sprite = require('sprite')
local Keyboard = require('keyboard')
local Joystick = require('joystick')
local World = require('world')


local Spriter = {}


--- New menu screen.
function Spriter:new(o)
  o = o or {}
  setmetatable(o, self)
  self.__index = self
  o:init()
  return o
end


function Spriter:init()
  self.keyboard = Keyboard:new()
  self.keyboard:action('escape', 'escape')
  self.keyboard:action('shake', 's')

  self.camera = Camera:new({ x = 0, y = 0, w = love.graphics.getWidth(), h = love.graphics.getHeight()})
  self.camera.bounds = { x1 = -500, y1 = -500, x2 = 800, y2 = 600}
  self.camera.followFactor = { x = 0.5, y = 0.5 }
  self.camera.zoom = 3
  local camera = self.camera

  function love.resize(w, h)
    camera.w = w
    camera.h = h
  end

  self.sprite = Sprite:newSprite('player')
  self.sprite:setState('walk')
end


function Spriter:update(dt)
  self.keyboard:update()

  if self.keyboard.now.escape then love.event.quit() end

  self.sprite:update(dt)
end


function Spriter:draw()
  self.camera:push()
  love.graphics.setColor(255, 255, 255, 255)
  love.graphics.draw(self.sprite.sheet.image, self.sprite:getFrame(), 100, 100)
  self.camera:pop()

  love.graphics.print(love.timer.getFPS(), 5, 5)
end


return Spriter
