
--- Tile module.
-- Can be used as a base object for anything that needs a default update and
-- draw method.
-- @classmod Tile


local Tile = {}


--- New tile.
function Tile:new(o)
  o = o or {}
  setmetatable(o, self)
  self.__index = self
  o:init()
  return o
end


--- Init the tile.
function Tile:init()
  assert(type(self.x) == 'number', ' required arg x must be a number')
  assert(type(self.y) == 'number', 'required arg y must be a number')

  -- optional args
  self.types = self.types or {}
  if self.collidable == nil then self.collidable = false end

  --- x position
  -- @field self.x

  --- x position
  -- @field self.y

  --- types
  -- @field self.types

  --- is collidable
  -- @field self.collidable
end


return Tile
